/* $Id: flow.h,v 1.4 2002/06/14 13:54:04 aa5779 Exp $ */
#ifndef FLOW_H
#define FLOW_H

typedef void *flow_handle_t;
typedef int flow_pos_t;

typedef struct flow_class
{ 
	char *name;
	flow_handle_t (*open)(char *name, char *options, int writeable);
	void (*close)(flow_handle_t fh);
	int (*getc)(flow_handle_t fh);
	int (*ungetc)(flow_handle_t fh, int ch);
	int (*putc)(flow_handle_t fh, int ch);
	int (*puts)(flow_handle_t fh, char *str);
	flow_pos_t (*getpos)(flow_handle_t fh);
	int (*setpos)(flow_handle_t fh, flow_pos_t fp);
	int (*rewind)(flow_handle_t fh);
	char *(*flowctl)(flow_handle_t fh, char *ctl);
} flow_class;

flow_class *detect_flow_class(char *name, char **proper_name, char **options);
void register_new_flow(char *name, flow_class *fc);

#define FLOW_EOF (-1)
#define FLOW_ERROR (-2)

#endif

